#ifndef FALTER_H
#define FALTER_H
#include<iostream>

/**
 * \brief Sammler Klasse
 * Sammer sammelt Informationen aus einem Wort.
 */
class Sammler
{
public:
  virtual void put(char c)=0; /// liefert das Wort buchstabenweise
  virtual void print(std::ostream &ostr)=0; /// schreibt die Statistik auf ostr
  virtual void reset()=0;     /// setzt den Tustand zurueck  
};

inline std::ostream &operator<<(std::ostream& ostr,Sammler& s)
{
    s.print(ostr);
    return ostr;
}

/**
 * \brief Falter
 * Gray/Reuter,"Transaction Progessing" S.896
 */ 
class Falter : public Sammler
{
 public:
    virtual unsigned long getfaltung()=0;
};

class Falter8bit : public Falter
{
 private:
    unsigned long f;
    int pos;
    union
    {
	unsigned long l;
	char s[sizeof(unsigned long)];
    } u;
    void abschluss() { f=f^u.l;u.l=0; }
 public:
    Falter8bit() { reset(); }
    void put(char c);
    void print(std::ostream &ostr);
    void reset();
    unsigned long getfaltung();
};

class Falter6bit : public Falter
{
 private:
    unsigned long f;
    int pos;
    unsigned long s;
    void abschluss() { f=f^s;s=0; }
 public:
    Falter6bit() { reset(); }
    void put(char c);
    void print(std::ostream &ostr);
    void reset();
    unsigned long getfaltung();
};
#endif

