#include<iostream>
#include<stdlib.h>
#include<string.h>
#include"hash.h"

void usage()
{
    std::cerr << "-f6\t6bit-Falter (voreingestellt)\n"
	 << "-f8\t8bit-Falter\n"
	 << "-hf\tHash nach nochmaliger Faltungsmethode (voreingestellt)\n"
	 << "-h2m\tHash mit 2er-Potenzmodulo\n"
	 << "-b #\t Breite in Bits (8 voreingestellt)\n" 
	 << std::endl;
}

int main(int argc,char **argv)
{
    char puffer[4096];
    Falter *falter=NULL;
    Hash::HashFkt hfkt = hashfaltung;
    int breite=8;
    char **arg=argv+1;
    while(*arg!=NULL)
    {
	if(strcmp(*arg,"-f6")==0)
	{ 
	    if(falter) delete falter;
	    falter = new Falter6bit;
	}
	else if(strcmp(*arg,"-f8")==0)
	{
	    if(falter) delete falter;
	    falter = new Falter8bit;
	}
	else if(strcmp(*arg,"-hf")==0)
	{
	    hfkt=hashfaltung;
	}
	else if(strcmp(*arg,"-h2m")==0)
	{
	    hfkt=hash2pmodulo;
	}
	else if(strncmp(*arg,"-b",2)==0)
	{
	    const char *p=*arg+2;
	    if(p=='\0')
	    {
		arg++;
		if(*arg==NULL) { usage(); exit(1); }
		p=*arg;
	    }
	    breite=atoi(p);
	}
	else 
	{
	    usage();
	    exit(1);
	}
	arg++;
    }
    if(!falter) falter = new Falter6bit;
    Hash hash(falter,hfkt,breite);

    while(std::cin >> puffer)
    {
	std::cout << hash(puffer) << std::endl;
    }
    return 0;
}
